SystemOrganization addCategory: #'CS528su13-Tiki'!

WAComponent subclass: #TikiWeb
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiWeb methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/10/2013 18:57'!
style 
	^'.existingtag a:link {color:black; text-decoration:none}
	.existingtag a:visited{color:black; text-decoration:none}
	.existingtag a:hover { color:gray; text-decoration:none} 
	.existingtag a:active { color:black; text-decoration:none}
	
	.titletext { font-size:18px }
	#summarytext a:link {
		color:#66AA66; text-decoration:none
		}
	.newtag a:link {color:black; text-decoration:none}
	.newtag a:visited{color:black; text-decoration:none}
	.newtag a:hover{color:#FF2222; text-decoration:none}
	.newtag a:active { color:black; text-decoration:none}
	
	.nolink a:link {color:black; text-decoration:none}
	.nolink a:visited{color:black; text-decoration:none}
	.nolink a:hover{color:black; text-decoration:none}
	.nolink a:active { color:black; text-decoration:none}
		'! !

TikiWeb subclass: #TikiWebMain
	instanceVariableNames: 'allPages mainInput summaryInput currentPage editting makingnewpage expanded currentTag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiWebMain class methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/1/2013 14:25'!
canBeRoot
^true! !

!TikiWebMain class methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/1/2013 14:48'!
initialize
	super initialize! !

!TikiWebMain methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/10/2013 16:25'!
allTags
^(allPages tagDictionaryKeys)! !

!TikiWebMain methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/10/2013 17:24'!
defaultSummary
^'Input optional summary here'! !

!TikiWebMain methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/8/2013 20:34'!
findPageWithTag: aTag among: pagesDatabase
"you can just call this directly."
^ pagesDatabase findPageWithTag: aTag! !

!TikiWebMain methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/10/2013 18:41'!
initialize
super initialize.
self resetHomeOptions.

summaryInput:=self defaultSummary. "this is constant"
mainInput:='Test input'.
"currentPage:=TikiPage newFrom:'#fruit apples bananas #pets dog cat bear'."
"temp :=TikiPage newFrom:'#red car apple stopsign mars #blue sky ocean blueberry' id: #temp summary: 'testing pop-up window'."
allPages := TikiPageDatabase new.
allPages initialize. "I don't see why this isn't being called automatically"
self initializeSpanish.
currentPage:= allPages getFirstPage
! !

!TikiWebMain methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/10/2013 17:42'!
initializeSpanish
"#tenerque Tienes que #infinitives usar #agreement estos ejemplos."
allPages add: (TikiPage newFrom:'#tenerque Tienes que #infinitives usar #agreement estos ejemplos.' tag: #main summary: 'An example of a sentence').

allPages add: (TikiPage newFrom:'Tener que is an expression which means (have to). It is used by conjugating the verb #tener tener ' tag: #tenerque summary: 'Tener que means (have to)').
"#infinitives is missing to demonstrate creating a new page"
allPages add: (TikiPage newFrom:'#nolink Note that adjectives need to agree with the nouns they are modifying, so a masculine noun requires a masculine adjective or adverb.' tag:#agreement summary: 'The adjective/adverb must agree with the noun').
allPages add: (TikiPage newFrom:'#nolink Tener is the verb which means (to have) and is an irregular verb.' tag:#tener summary:'Tener means to have').! !

!TikiWebMain methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/1/2013 14:43'!
mainInput
^mainInput! !

!TikiWebMain methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/1/2013 14:54'!
mainInput: anInput
mainInput:=anInput! !

!TikiWebMain methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/10/2013 18:21'!
processSummaryClick: aSymbol
	currentPage:=(self findPageWithTag: aSymbol among: allPages).
	expanded:=''.! !

!TikiWebMain methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/10/2013 18:48'!
processTagClick: aSymbol
	(aSymbol = #nolink) ifTrue: [^'This text is not a link'].
		
	((self allTags) includes: aSymbol) ifFalse:[
		makingnewpage:=true.
		editting:=true.
		currentTag:=aSymbol.
	] ifTrue:[
		makingnewpage:=false.
		expanded=aSymbol ifTrue:[
			currentPage:=allPages findPageWithTag: aSymbol.
			expanded:=''
			] ifFalse:	[
			expanded:=aSymbol.
			]
		]! !

!TikiWebMain methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/10/2013 18:36'!
renderContentOn: html 
	"html heading: 'Version 10'.
	html break."
	html form:[
		editting ifTrue:[self renderEditting: html.
		] ifFalse:[
			(currentPage orderedLinks) do:[
				:each | self renderPageLink:html for: each
			].
		].
		html break.
		self renderSubmitButton: html.
		self renderHomeButton: html.
	].	
	html break.
	html anchor
		callback: [ self processSummaryClick: #temp ];
		with: 'Test pop-up window'.! !

!TikiWebMain methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/10/2013 18:37'!
renderEditting: html
	makingnewpage ifTrue:[self renderEdittingNewPage: html].
	html textInput
	on: #mainInput of: self
! !

!TikiWebMain methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/10/2013 18:37'!
renderEdittingNewPage: html
	html span
	class:'titletext';
	with:[ html text: 'Making new page: #',(currentTag asString)].

	html break.
	html textInput 
		on: #summaryInput of: self.
	html break.
! !

!TikiWebMain methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/10/2013 18:40'!
renderHomeButton: html
	html submitButton
		callback: [ currentPage:=(allPages getFirstPage). self resetHomeOptions];
		text: 'Home screen'.
! !

!TikiWebMain methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/10/2013 18:59'!
renderPageLink: html for: each
	| tempAllTags |
	tempAllTags := self allTags.
	html span
	class: ((tempAllTags includes: each) 
		ifFalse: [ (each asSymbol = #nolink) ifTrue:['nolink'] ifFalse:['newtag']]
		ifTrue: [ 'existingtag' ]);
	with: [ 
		html anchor
		callback: [ self processTagClick: each asSymbol ];
		with: (currentPage linkDictionary at: each ifAbsent: [ '(' , each asString , ')' ]).

		html text: ' '.
		each = expanded ifTrue: [ 
			html span
			id: 'summarytext';
			with: [ 
				html anchor
				callback: [ self processSummaryClick: each asSymbol ];
				with: ' (' , (allPages findPageWithTag: each asSymbol) summary , ') ' 
			]."end span with"
		html text: ' ' 
		]"end expanded with" 
	]"end span with"! !

!TikiWebMain methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/10/2013 18:18'!
renderSubmitButton: html
	html submitButton 
	callback: [self submitEdit];
	text: (editting ifTrue: ['Submit page'] ifFalse: [ 'Start editting' ]).
! !

!TikiWebMain methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/10/2013 18:40'!
resetHomeOptions
	expanded:=''.
	editting:=false.
	makingnewpage:=false.! !

!TikiWebMain methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/10/2013 18:53'!
submitEdit
editting ifFalse:[
	editting:=true
] ifTrue:[
	editting:=false.
	(mainInput beginsWith: '#') ifFalse:[mainInput:= '#nolink ',mainInput]. 
	makingnewpage ifTrue:[
		(summaryInput = self defaultSummary) ifTrue:[summaryInput=''].
		currentPage:=TikiPage newFrom: mainInput tag: currentTag summary: summaryInput.
		allPages add: currentPage.
	].
	currentPage makeLinkDictionaryFrom: mainInput.
	expanded=''.
]! !

!TikiWebMain methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/10/2013 16:53'!
summaryInput
^summaryInput! !

!TikiWebMain methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/10/2013 16:53'!
summaryInput: anInput
summaryInput:=anInput! !

TikiWeb subclass: #TikiWebPopupWindow
	instanceVariableNames: 'mainInput currentPage editting expanded tenerquePage tenerPage infinitivePage agreementPage mainPage pageDB'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiWebPopupWindow class methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/5/2013 23:15'!
canBeRoot
^true! !

!TikiWebPopupWindow class methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/5/2013 23:15'!
initialize
	super initialize! !

!TikiWebPopupWindow methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/7/2013 22:07'!
dialogContentFor: aSymbal
	^('You clicked on ',aSymbal asString,' objects')! !

!TikiWebPopupWindow methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/8/2013 23:56'!
findPageWithId: anID among: pagesCollection 
	"This should be replaced when ID checking improves"
	^(pagesCollection detect: [:eachpage| eachpage tag = anID] ifNone: mainPage).! !

!TikiWebPopupWindow methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/8/2013 23:51'!
initialize
	super initialize.
	editting:=false.
	mainInput:='Test input'.
	pageDB := TikiDataBaseServer getInstance connectToDB: ''.

! !

!TikiWebPopupWindow methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/5/2013 23:15'!
mainInput
^mainInput! !

!TikiWebPopupWindow methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/5/2013 23:15'!
mainInput: anInput
mainInput:=anInput! !

!TikiWebPopupWindow methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/8/2013 23:51'!
processSummaryClick: aSymbol
	"(aSymbol=#nolink) ifFalse:["
		currentPage:=(self findPageWithTag: aSymbol among: pageDB).
	"]"! !

!TikiWebPopupWindow methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/8/2013 23:51'!
processTagClick: aSymbol 
	"(aSymbol=#nolink) ifFalse:["
		expanded=aSymbol ifTrue:[currentPage:=(self findPageWithTag: aSymbol among: pageDB). expanded:=''] ifFalse:	[expanded:=aSymbol.]
	"]"
	"self inform: 'You clicked on ',( aSymbol asString)"! !

!TikiWebPopupWindow methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/6/2013 12:42'!
renderBox: aString on: html with: contentString
	html div id: aString; class: 'box'; with: [
		html div class: 'header'.
		html div
			class: 'content';
			with: contentString ]! !

!TikiWebPopupWindow methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/7/2013 22:12'!
renderContentOn: html 
	 | id anchorId|
	html heading: 'Chapter 1 Seciont 2: Colors'.
	html break.

	html code
		id: #tempID;
		with: DateAndTime now.
		
	html break.

	html div
		id: (id := html nextId);
		script: (html jQuery new dialog
     			title: '';
	     		autoOpen: false);
     		with: [ self renderDialogOn: html].

	html  anchor
			id: (anchorId := html nextId);
			onClick: (html jQuery ajax 
							script: [ :s | s << (s jQuery: #boxcontent) html: (self dialogContentFor: #red) ]
						);
			onClick: ((html jQuery id: id) dialog
						open
						);
			with: 'car apple stopsign mars'.
	html break.
	html  anchor
			id: (anchorId := html nextId);
			onClick: ((html jQuery id: id) dialog
						open
						);
			onClick: (html jQuery ajax 
							script: [ :s | s << (s jQuery: #boxcontent) html: (self dialogContentFor: #blue) ]
						);
			with: 'sky ocean blueberry'.


! !

!TikiWebPopupWindow methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/7/2013 21:09'!
renderDialogOn: html
	html div id: (html nextId); class: 'box'; with: [
		html div class: 'header'.
		html div
			id: #boxcontent;
			class: 'content';
			with: 'Brief explanation, cross references, all forum posts about this, etc' ]! !

!TikiWebPopupWindow methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/7/2013 20:26'!
style 
	^'
	body { 
	margin: 0;
	font: 11px Lucida Grande, Verdana, Arial, Helvetica, sans serif;
	background: url(background.gif) repeat-x #fff;
}
img {
	border: 0px;
}

#header {
	height: 110px;
	text-align: right;
	background: url(SUAllTestLibrary / #headerGif ) #7e9e50;
	color: #333;
	margin-bottom:25px;
}

#logo {
	float: left;
}

#menu {
	list-style-type: none;
	position: absolute;
	right: 0px;
	top: 95px;
	margin: 0px;
	padding: 0px;
	margin-top: -10px;
	padding-right: 5px;
}

#menu li {
	text-transform: lowercase;
	float: left;
}

#menu li a {
	display: block;
	width: 110px;
	padding-top: 9px;
	height: 16px;
	text-align: center;
	text-decoration: none;
	color: #fff;
	font-weight: bold;
	background: url(menu.gif) 110px 0px;
}

#menu a.active {
	color: #7f9f50;
	background: url(menu.gif) 0px 0px;
}

#menu a:hover {
	color: #7f9f50;
	background: url(menu.gif) 0px 0px;
}

#content {
	margin-left: 60px;
	margin-right: 60px;
}

#content h1 {
	font: 22px Georgia, serif;
	color: #7e9e50;
	font-weight: normal;
	margin: 0px;
	padding: 0px;
	text-transform: lowercase;
	font-style: italic;
	padding-bottom: 4px;
	border-bottom: 1px dotted #c5dea1;
	clear: left;
}

#content h2 {
	font: 18px Georgia, serif;
	color: #7e9e50;
	font-size: 15px;
	font-weight: normal;
	margin: 0px;
	padding: 0px;
	margin-top: 20px;
	text-transform: lowercase;
	font-style: italic;
}

#content h3 {
	font: 13px Lucida Grande, Verdana, Arial, Helvetica, sans serif;
	margin: 0px;
	padding: 0px;
	margin-left: 10px;
	margin-top: 10px;
	font-weight: bold;
	text-transform: lowercase;
	color: #444444;
}

#content p, div.paragraph {
	font-size: 12px;
	line-height: 1.7;
	color: #444444;
	margin-left: 10px;
	margin-top: 10px;
}

/* demo box */
div.box {
	width: 120px;
	height: 120px;
	margin-right: 10px;
	margin-bottom: 10px;

}

div.box div.header {
	height: 23px;
	/*background: url(SUAllTestLibrary / #headerGif) repeat-x;*/
	background: #7e9e50;
}

div.box div.content {
	padding-top: 1em;
	text-align: center;
	/*background: url(SUAllTestLibrary / #demoGif);*/
	background: #f5f5f5;
}

div.smallBox {
	width: 100%;
	height: 100%;
	background: url(demo.gif) ;
}

div.smallBox div.header {
	height: 20px;
	background: url(demo-logo.gif) repeat-x;
}
div.smallBox div.content {
	padding-top: 1em;
	text-align: center;
}

/* source code */
div.source {
	margin: 5px;
	padding: 5px;
	border: 1px solid #dddddd;
	background: #f5f5f5;
	font: 12px Lucida Sans Typewriter, Courier, monospace;
}
a:link {color:black; text-decoration:none}
a:visited{color:black; text-decoration:none}
a:hover { color:gray; text-decoration:none} 
a:active { color:black; text-decoration:none}
'! !

OrderedCollection subclass: #TikiPageDatabase
	instanceVariableNames: 'tagDictionary lastPageId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiPageDatabase methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/10/2013 16:43'!
add: aPage
"public, use this to add pages to the database"
(lastPageId > 0) ifTrue: [super add: aPage afterIndex: lastPageId.] ifFalse: [super add: aPage].
self updateTagDictionaryWith: (aPage tag). "this actually updates it with the tag"
! !

!TikiPageDatabase methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/10/2013 16:44'!
findPageWithTag: aSymbol
"public"
( (tagDictionary keys) includes: aSymbol) ifTrue: [ ^ self at: (tagDictionary at: aSymbol)]  ifFalse: [^ self tagNotFoundPage]! !

!TikiPageDatabase methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/8/2013 19:38'!
getFirstPage
self assert: (self size) > 0. 
^(self at: 1)
! !

!TikiPageDatabase methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/10/2013 16:04'!
initialize
	tagDictionary := Dictionary new.
	super initialize.	
	"Transcript show: 'Initialized tagDictionary'."
	lastPageId:=0.! !

!TikiPageDatabase methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/10/2013 16:23'!
tagDictionaryKeys
^ (tagDictionary keys)! !

!TikiPageDatabase methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/8/2013 20:17'!
tagNotFoundPage
"This is the page corresponding to the not found page "
	^self getFirstPage! !

!TikiPageDatabase methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/10/2013 16:43'!
updateTagDictionaryWith: aSymbol
"(This should be private?)"
lastPageId:=lastPageId+1.
tagDictionary at: aSymbol put: lastPageId! !

Object subclass: #TikiCachedWebPage
	instanceVariableNames: 'id html summary rank'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiCachedWebPage commentStamp: '<historical>' prior: 0!
Instances are created when user's requesting a page and cached in TikiWebPagePool.

The instances have ready to view html content in memory so if there's another request for the page, html content can be sent to user without overhead.

Rank will be used for tag clound.!

Object subclass: #TikiDataBaseServer
	instanceVariableNames: 'dbPool'
	classVariableNames: 'inst'
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiDataBaseServer commentStamp: '<historical>' prior: 0!
The system may have many TikiWeb instances. Some of them are accessing the same database for web page contents. Image all cs528 students reading the course website.

Usually database systems can support several requests simutaneous, so the server doesn't have to keep multiple TikiPageDatabase instances.

This class, TikiDataBaseServer, keeps one TikiPageDatabase instance per database URL. Itself has a singleton instance per seaside server.!

!TikiDataBaseServer class methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/8/2013 23:41'!
getInstance
	inst = nil ifTrue: [ inst := self new ].
	^inst! !

!TikiDataBaseServer methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/8/2013 23:47'!
connectToDB: aURL
	dbPool keysDo: [ :each | each = aURL ifTrue: [ ^dbPool at: aURL ] ].
	dbPool at: aURL put: TikiPageDatabase new .
	^ dbPool at: aURL! !

!TikiDataBaseServer methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/8/2013 23:42'!
initialize 
	dbPool := Dictionary new! !

Object subclass: #TikiPage
	instanceVariableNames: 'orderedLinks linkDictionary summary tag'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiPage class methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/1/2013 18:38'!
newFrom:aString
|tempPage|
tempPage:=TikiPage new.
tempPage makeLinkDictionaryFrom:aString.
^tempPage! !

!TikiPage class methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/8/2013 20:32'!
newFrom:aString tag: aTag summary: aSummary
|tempPage|
tempPage:=TikiPage new.
tempPage tag:aTag summary:aSummary.
tempPage makeLinkDictionaryFrom:aString.
^tempPage! !

!TikiPage methodsFor: 'as yet unclassified' stamp: 'NateOrlow 6/1/2013 13:28'!
initialize 
linkDictionary:=Dictionary new.
orderedLinks:=OrderedCollection new.
summary:=''.! !

!TikiPage methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/1/2013 18:33'!
linkDictionary
^linkDictionary! !

!TikiPage methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/8/2013 20:31'!
makeLinkDictionaryFrom: aString 
|rawLinkList tempTag tempText tempLength tempIndex|

rawLinkList:=aString findTokens:$#.
"linkDictionary:= Dictionary new."
orderedLinks removeAll.
(linkDictionary keys) do: [ :each |  linkDictionary removeKey: each ].

rawLinkList do: [:each | tempLength:=each size. tempIndex:=each indexOf:(Character space). tempTag:=each copyFrom: 1 to: tempIndex-1. tempText:= each copyFrom: tempIndex+1 to:tempLength. orderedLinks add:tempTag. linkDictionary at: (tempTag asSymbol) put: tempText].
! !

!TikiPage methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/3/2013 12:29'!
orderedLinks
^orderedLinks! !

!TikiPage methodsFor: 'as yet unclassified' stamp: 'NateOrlow 6/1/2013 17:42'!
summary
^summary! !

!TikiPage methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/8/2013 20:29'!
tag
^tag! !

!TikiPage methodsFor: 'as yet unclassified' stamp: 'NateOrlow 7/8/2013 20:30'!
tag: aSymbol summary: aSummary
tag:=aSymbol.
summary:=aSummary.! !

Object subclass: #TikiPageAgingStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiPageAgingStrategy commentStamp: '<historical>' prior: 0!
Used by TikiWebPagePool!

!TikiPageAgingStrategy methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/9/2013 22:54'!
activate: page in: sortedCollection 
! !

!TikiPageAgingStrategy methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/9/2013 22:19'!
insert: aPage to: sortedByAge 
	"Insert aPage into a collection, sortedByAge. Subclasses can implement their own sortedByAge classes and override this method"
	! !

!TikiPageAgingStrategy methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/9/2013 22:53'!
retirePagesFrom: theSortedCollection
	! !

Object subclass: #TikiPagePreloadStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiPagePreloadStrategy commentStamp: '<historical>' prior: 0!
Used by TikiWebPagePool as the strategy to decide which pages should be preloaded to accelerate load time.!

!TikiPagePreloadStrategy methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/9/2013 22:14'!
computePageToBeLoad: aPage
	"given aPage, return an array with page ID's to be preloaded in itsuper "
	^#()! !

Object subclass: #TikiSerializable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiSerializable commentStamp: '<historical>' prior: 0!
The pages and pop-up windows are rendered when they are needed by the web, or, they are opened by user clicks.

TikiSerialiable instances represent these objects. They can be edited by users and serialized into disk.
!

TikiSerializable subclass: #TikiPageFile
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

Object subclass: #TikiWebPagePool
	instanceVariableNames: 'pagePool sortedByAge preloadStrategy pageSema strategySema capacity agingStrategy'
	classVariableNames: 'inst'
	poolDictionaries: ''
	category: 'CS528su13-Tiki'!

!TikiWebPagePool commentStamp: '<historical>' prior: 0!
Singleton per Seaside server. It maintains a pool for TikiWebPage instances, so that TikiWebPage not being viewed by user can be cached here. 

If a TikiWebPage instance ages (decided with ageStrategy), it'll be removed from pool.

Some TikiWebPage instances may be preloaded according to preloadStrategy in order to be rendered faster. Potential preloadStrategy include to load next page of current one.!

!TikiWebPagePool class methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/9/2013 22:07'!
getThePool
	inst = nil ifTrue: [ inst := self new ].
	^inst! !

!TikiWebPagePool methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/9/2013 22:53'!
add: aPage withID: id
	"Add a page to pool. Remove old pages if pool size exceeds capacity
	This has to be called with pageSema held"
	| oldpages |
	pagePool at: id put: aPage.
	agingStrategy add: aPage withID: id.
	self pageCount > (self capacity ) ifTrue: [ 
				oldpages := agingStrategy retirePagesFrom: sortedByAge ]
			ifFalse: [ ^nil ].
	oldpages do: [ :each | pagePool removeKey: each ]
! !

!TikiWebPagePool methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/9/2013 22:23'!
ageStrategy: anAgeStrategy
! !

!TikiWebPagePool methodsFor: 'accessing' stamp: 'PengLiu 7/9/2013 22:22'!
capacity
	^capacity! !

!TikiWebPagePool methodsFor: 'accessing' stamp: 'PengLiu 7/9/2013 22:22'!
capacity: anInteger
	capacity := anInteger ! !

!TikiWebPagePool methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/9/2013 22:54'!
findPage: id
	| page |
	page := pagePool at: id 
		ifAbsent: [ ^nil ].
	agingStrategy activate: id in: sortedByAge.
	^page! !

!TikiWebPagePool methodsFor: 'initialize-release' stamp: 'PengLiu 7/9/2013 22:25'!
initialize 
	pagePool := Dictionary new! !

!TikiWebPagePool methodsFor: 'as yet unclassified' stamp: 'PengLiu 7/9/2013 22:26'!
pageCount
	^pagePool size! !
TikiWebPopupWindow initialize!
TikiWebMain initialize!
